import os
import sys
import termios
import time
import tty

SPACE_BUFFER = ' '*5
NSPACE_BUFFER = '\n%s'%SPACE_BUFFER
COUNT_STATUS_LINES_RESERVED = 3

class UnixIo(object):
    def __init__(self, context):
        self.context = context
    def clear_screen(self):
        os.system('clear')
        #print chr(27) + "[2J"
    def getchar(self):
        fd = sys.stdin.fileno()
        old_settings = termios.tcgetattr(fd)
        try:
            tty.setraw(sys.stdin.fileno())
            ch = sys.stdin.read(1)
        finally:
            termios.tcsetattr(fd, termios.TCSADRAIN, old_settings)
        return ch
    def ask_yn(self, msg, default, clear=True):
        def say_no():
            print 'No'
            time.sleep(0.1)
        def say_yes():
            print 'Yes'
            time.sleep(0.1)

        if clear:
            self.clear_screen()

        print '\n%s'%msg,
        if None != default:
            if default:
                print "[y]"
            else:
                print "[n]"
        else:
            print
        r = self.getchar()
        if r in ['y', 'Y']:
            say_yes()
            return True
        if r in ['n', 'N']:
            say_no()
            return False

        if default:
            say_yes()
            return True
        else:
            say_no()
            return False
    def get_wordy_input(self):
        sys.stdout.write(':')
        input = raw_input()
        return input
    def redraw(self, lines, with_status=False):
        status_buffer = COUNT_STATUS_LINES_RESERVED - len(self.context.status)

        sb = []
        #
        # status messages, or gaps in their stead
        for i in range(status_buffer):
            sb.append('')
        if with_status:
            sb.extend(self.context.status)
        #
        # render the supplied lines
        sb.extend(lines)

        out = "%s%s"%(SPACE_BUFFER, NSPACE_BUFFER.join(sb))

        self.clear_screen()
        print out


